/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LRU.xs. Do not edit this file, edit LRU.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LRU.xs"
/*
 * Copyright 2011 Alexandr Gomoliako 
 *
 * Copyright (c) 2002-2003 Marcus Holland-Moritz. All rights reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the same terms as Perl itself.
 */

/* based on Tie::Hash::Indexed 0.05 */


#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef THI_DEBUGGING
#define NEED_sv_2pv_nolen
#endif

#include "ppport.h"


#define XSCLASS "Tie::Hash::LRU"

/*-----------------*/
/* debugging stuff */
/*-----------------*/

#define DB_THI_MAIN      0x00000001

#ifdef THI_DEBUGGING
#  define DEBUG_FLAG(flag) \
            (DB_THI_ ## flag & gs_dbflags)
#  define THI_DEBUG(flag, x) \
            do { if (DEBUG_FLAG(flag)) debug_printf x; } while (0)
#  define DBG_CTXT_FMT "%s"
#  define DBG_CTXT_ARG (GIMME_V == G_VOID   ? "0=" : \
                       (GIMME_V == G_SCALAR ? "$=" : \
                       (GIMME_V == G_ARRAY  ? "@=" : \
                                              "?="   \
                       )))
#else
#  define THI_DEBUG(flag, x) (void) 0
#endif

#define THI_DEBUG_METHOD                                                       \
          THI_DEBUG(MAIN, (DBG_CTXT_FMT XSCLASS "::%s\n", DBG_CTXT_ARG, method))

#define THI_DEBUG_METHOD1(fmt, arg1)                                           \
          THI_DEBUG(MAIN, (DBG_CTXT_FMT XSCLASS "::%s(" fmt ")\n",             \
                           DBG_CTXT_ARG, method, arg1))

#define THI_DEBUG_METHOD2(fmt, arg1, arg2)                                     \
          THI_DEBUG(MAIN, (DBG_CTXT_FMT XSCLASS "::%s(" fmt ")\n",             \
                           DBG_CTXT_ARG, method, arg1, arg2))

#define THI_METHOD( name )         const char * const method = #name
#define THI_METHOD_VAR             const char * method = ""
#define THI_METHOD_SET( string )   method = string

/*---------------------------------*/
/* check object against corruption */
/*---------------------------------*/

#define THI_CHECK_OBJECT                                                       \
        do {                                                                   \
          if (THIS == NULL )                                                   \
            Perl_croak(aTHX_ "NULL OBJECT IN " XSCLASS "::%s", method);        \
          if (THIS->signature != THI_SIGNATURE)                                \
          {                                                                    \
            if (THIS->signature == 0xDEADC0DE)                                 \
              Perl_croak(aTHX_ "DEAD OBJECT IN " XSCLASS "::%s", method);      \
            Perl_croak(aTHX_ "INVALID OBJECT IN " XSCLASS "::%s", method);     \
          }                                                                    \
          if (THIS->hv == NULL || THIS->root == NULL)                          \
            Perl_croak(aTHX_ "OBJECT INCONSITENCY IN " XSCLASS "::%s", method);\
        } while (0)

/*--------------------------------*/
/* very simple doubly linked list */
/*--------------------------------*/

#define IxLink_new(link)                                                       \
        do {                                                                   \
          Newz(0, link, 1, IxLink);                                            \
          (link)->key = NULL;                                                  \
          (link)->val = NULL;                                                  \
          (link)->prev = (link)->next = link;                                  \
        } while (0)

#define IxLink_delete(link)                                                    \
        do {                                                                   \
          Safefree(link);                                                      \
          link = NULL;                                                         \
        } while (0)

#define IxLink_push(root, link)                                                \
        do {                                                                   \
          (link)->prev       = (root)->prev;                                   \
          (link)->next       = (root);                                         \
          (root)->prev->next = (link);                                         \
          (root)->prev       = (link);                                         \
        } while (0)

#define IxLink_unshift(root, link)                                             \
        do {                                                                   \
          (link)->next       = (root)->next;                                   \
          (link)->prev       = (root);                                         \
          (root)->next->prev = (link);                                         \
          (root)->next       = (link);                                         \
        } while (0)

#define IxLink_extract(link)                                                   \
        do {                                                                   \
          (link)->prev->next = (link)->next;                                   \
          (link)->next->prev = (link)->prev;                                   \
          (link)->next       = (link);                                         \
          (link)->prev       = (link);                                         \
        } while (0)


/*===== TYPEDEFS =============================================================*/

typedef struct sIxLink IxLink;

struct sIxLink {
  SV     *key;
  SV     *val;
  IxLink *prev;
  IxLink *next;
};

typedef struct {
  HV        *hv;
  IxLink    *root;
  IxLink    *iter;
  U32        max;
  U32        count;
  U32        signature;
  int        autohit;
#define THI_SIGNATURE 0x54484924
} IXHV;

/*---------------*/
/* serialization */
/*---------------*/

typedef struct {
    char id[4];
#define THI_SERIAL_ID          "THL!"   /* this must _never_ be changed */
    unsigned char major;
#define THI_SERIAL_REV_MAJOR    0        /* incompatible changes */
    unsigned char minor;
#define THI_SERIAL_REV_MINOR    0        /* compatible changes */
} SerialRev;

typedef struct {
  SerialRev rev;
  /* add configuration items here, don't change order, only use bytes */
} Serialized;


/*===== STATIC VARIABLES =====================================================*/

#ifdef THI_DEBUGGING
static U32 gs_dbflags;
#endif


/*===== STATIC FUNCTIONS =====================================================*/

#ifdef THI_DEBUGGING
static void debug_printf(char *f, ...)
{
  va_list l;
  va_start(l, f);
  vfprintf(stderr, f, l);
  va_end(l);
}

static void set_debug_opt(pTHX_ const char *dbopts)
{
  if (strEQ(dbopts, "all"))
    gs_dbflags = 0xFFFFFFFF;
  else
  {
    gs_dbflags = 0;
    while (*dbopts)
    {
      switch (*dbopts)
      {
        case 'd': gs_dbflags |= DB_THI_MAIN;  break;
        default:
          Perl_croak(aTHX_ "Unknown debug option '%c'", *dbopts);
          break;
      }
      dbopts++;
    }
  }
}
#endif

static void store(pTHX_ IXHV *THIS, SV *key, SV *value)
{
  HE *he;

  if ((he = hv_fetch_ent(THIS->hv, key, 1, 0)) == NULL)
    Perl_croak(aTHX_ "couldn't store value");
  
  if (SvTYPE(HeVAL(he)) == SVt_NULL)
  {
    IxLink *cur;

    IxLink_new(cur);
    IxLink_unshift(THIS->root, cur);
    sv_setiv(HeVAL(he), PTR2IV(cur));
    cur->key = newSVsv(key);
    cur->val = newSVsv(value);

    if (THIS->count++ >= THIS->max) {
      SV *sv;

      cur = THIS->root->prev;

      if ((sv = hv_delete_ent(THIS->hv, cur->key, 0, 0)) == NULL)
      {
        Perl_croak(aTHX_ "Cannot delete entry: key '%s' not found", SvPV_nolen(cur->key));
      }

      SvREFCNT_dec(cur->key);
      sv = cur->val;

      if (THIS->iter == cur)
      {
        THIS->iter = cur->prev;
      }

      IxLink_extract(cur);
      IxLink_delete(cur);

      THIS->count--;

      SvREFCNT_dec(sv);

    }
  }
  else
    sv_setsv((INT2PTR(IxLink *, SvIV(HeVAL(he))))->val, value);
}


/*===== XS FUNCTIONS =========================================================*/

#line 265 "LRU.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 409 "LRU.c"

XS_EUPXS(XS_Tie__Hash__LRU_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "CLASS, MAX, ...");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	U32	MAX = (unsigned long)SvUV(ST(1))
;
#line 267 "LRU.xs"
		THI_METHOD(TIEHASH);
		int i;

#line 426 "LRU.c"
	IXHV *	RETVAL;
#line 271 "LRU.xs"
		THI_DEBUG_METHOD1("'%i'", MAX);

		Newz(0, RETVAL, 1, IXHV);
		IxLink_new(RETVAL->root);
		RETVAL->iter      = NULL;
		RETVAL->hv        = newHV();
		RETVAL->signature = THI_SIGNATURE;
		RETVAL->max       = MAX;
		RETVAL->count     = 0; /* last is a general node */
		RETVAL->autohit   = 1;

		for (i = 2; i < items; i += 2)
		{
		  store(aTHX_ RETVAL, ST(i), ST(i + 1));
		}

#line 445 "LRU.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, CLASS, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__Hash__LRU_autohit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_autohit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, AUTOHIT");
    {
	int	AUTOHIT = (int)SvIV(ST(1))
;
#line 296 "LRU.xs"
		THI_METHOD(NEXTKEY);

#line 469 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::autohit(): THIS is not a blessed SV reference")
;
#line 299 "LRU.xs"
		THI_DEBUG_METHOD;
		THI_CHECK_OBJECT;

		THIS->autohit = AUTOHIT;
#line 485 "LRU.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__Hash__LRU_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 308 "LRU.xs"
		THI_METHOD(DESTROY);
		IxLink *cur;

#line 502 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::DESTROY(): THIS is not a blessed SV reference")
;
#line 312 "LRU.xs"
		THI_DEBUG_METHOD;
		THI_CHECK_OBJECT;

		for (cur = THIS->root->next; cur != THIS->root;)
		{
		  IxLink *del = cur;
		  cur = cur->next;
		  SvREFCNT_dec(del->key);
                  if (del->val)
		    SvREFCNT_dec(del->val);
		  IxLink_delete(del);
		}

		IxLink_delete(THIS->root);
		SvREFCNT_dec(THIS->hv);

		THIS->max       = 0;
		THIS->count     = 0;
		THIS->root      = NULL;
		THIS->iter      = NULL;
		THIS->hv        = NULL;
		THIS->signature = 0xDEADC0DE;

		Safefree(THIS);
#line 538 "LRU.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__Hash__LRU_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	key = ST(1)
;
#line 343 "LRU.xs"
		THI_METHOD(FETCH);
		HE *he;
		IxLink *cur;

#line 560 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::FETCH(): THIS is not a blessed SV reference")
;
#line 348 "LRU.xs"
		THI_DEBUG_METHOD1("'%s'", SvPV_nolen(key));
		THI_CHECK_OBJECT;

		if ((he = hv_fetch_ent(THIS->hv, key, 0, 0)) == NULL)
		  XSRETURN_UNDEF;

		if (THIS->autohit) {
		  cur = INT2PTR(IxLink *, SvIV(HeVAL(he))); 

		  IxLink_extract(cur); 
		  IxLink_unshift(THIS->root, cur); 
		}

		ST(0) = sv_mortalcopy((INT2PTR(IxLink *, SvIV(HeVAL(he))))->val);
		XSRETURN(1);
#line 587 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, key, value");
    {
	SV *	key = ST(1)
;
	SV *	value = ST(2)
;
#line 371 "LRU.xs"
		THI_METHOD(STORE);

#line 608 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::STORE(): THIS is not a blessed SV reference")
;
#line 374 "LRU.xs"
		THI_DEBUG_METHOD2("'%s', '%s'", SvPV_nolen(key), SvPV_nolen(value));
		THI_CHECK_OBJECT;

		store(aTHX_ THIS, key, value);
#line 624 "LRU.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__Hash__LRU_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 383 "LRU.xs"
		THI_METHOD(FIRSTKEY);

#line 642 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::FIRSTKEY(): THIS is not a blessed SV reference")
;
#line 386 "LRU.xs"
		THI_DEBUG_METHOD;
		THI_CHECK_OBJECT;

		THIS->iter = THIS->root->next;

		if (THIS->iter->key == NULL)
		  XSRETURN_UNDEF;

		ST(0) = sv_mortalcopy(THIS->iter->key);
		XSRETURN(1);
#line 664 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, last");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	last = ST(1)
;
#line 403 "LRU.xs"
		THI_METHOD(NEXTKEY);

#line 685 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::NEXTKEY(): THIS is not a blessed SV reference")
;
#line 406 "LRU.xs"
		THI_DEBUG_METHOD1("'%s'", SvPV_nolen(last));
		THI_CHECK_OBJECT;

		THIS->iter = THIS->iter->next;

		if (THIS->iter->key == NULL)
		  XSRETURN_UNDEF;

		ST(0) = sv_mortalcopy(THIS->iter->key);
		XSRETURN(1);
#line 707 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	key = ST(1)
;
#line 423 "LRU.xs"
		THI_METHOD(EXISTS);

#line 728 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::EXISTS(): THIS is not a blessed SV reference")
;
#line 426 "LRU.xs"
		THI_DEBUG_METHOD1("'%s'", SvPV_nolen(key));
		THI_CHECK_OBJECT;

		if (hv_exists_ent(THIS->hv, key, 0))
		  XSRETURN_YES;
		else
		  XSRETURN_NO;
#line 747 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	key = ST(1)
;
#line 440 "LRU.xs"
		THI_METHOD(DELETE);
		IxLink *cur;
		SV *sv;

#line 770 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::DELETE(): THIS is not a blessed SV reference")
;
#line 445 "LRU.xs"
		THI_DEBUG_METHOD1("'%s'", SvPV_nolen(key));
		THI_CHECK_OBJECT;

		if ((sv = hv_delete_ent(THIS->hv, key, 0, 0)) == NULL)
		{
		  THI_DEBUG(MAIN, ("key '%s' not found\n", SvPV_nolen(key)));
		  XSRETURN_UNDEF;
		}

		cur = INT2PTR(IxLink *, SvIV(sv));
		SvREFCNT_dec(cur->key);
		sv = cur->val;

		if (THIS->iter == cur)
		{
		  THI_DEBUG(MAIN, ("need to move current iterator %p -> %p\n",
		                   THIS->iter, cur->prev));
		  THIS->iter = cur->prev;
		}

		IxLink_extract(cur);
		IxLink_delete(cur);

		THIS->count--;

		THI_DEBUG(MAIN, ("key '%s' deleted\n", SvPV_nolen(key)));

		ST(0) = sv_2mortal(sv);
		XSRETURN(1);
#line 811 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 479 "LRU.xs"
		THI_METHOD(CLEAR);
		IxLink *cur;

#line 831 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::CLEAR(): THIS is not a blessed SV reference")
;
#line 483 "LRU.xs"
		THI_DEBUG_METHOD;
		THI_CHECK_OBJECT;

		for (cur = THIS->root->next; cur != THIS->root;)
		{
		  IxLink *del = cur;
		  cur = cur->next;
		  SvREFCNT_dec(del->key);
                  if (del->val)
		    SvREFCNT_dec(del->val);
		  IxLink_delete(del);

		  THIS->count--;
		}

		THIS->root->next = THIS->root->prev = THIS->root;

		hv_clear(THIS->hv);
#line 861 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 506 "LRU.xs"
		THI_METHOD(SCALAR);

#line 880 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::SCALAR(): THIS is not a blessed SV reference")
;
#line 509 "LRU.xs"
		THI_DEBUG_METHOD;
		THI_CHECK_OBJECT;
#ifdef hv_scalar
		ST(0) = hv_scalar(THIS->hv);
#else
		ST(0) = sv_newmortal();
		if (HvFILL(THIS->hv)) 
		  Perl_sv_setpvf(aTHX_ ST(0), "%ld/%ld", (long)HvFILL(THIS->hv),
		                                       (long)HvMAX(THIS->hv)+1);
		else
		  sv_setiv(ST(0), 0);
#endif
		XSRETURN(1);
#line 905 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_STORABLE_freeze); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_STORABLE_freeze)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, cloning");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	cloning = (int)SvIV(ST(1))
;
#line 529 "LRU.xs"
		THI_METHOD(STORABLE_freeze);
		Serialized s;
		IxLink *cur;
		int n;

#line 929 "LRU.c"
	IXHV *	THIS;

	if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
	  IV tmp = SvIV((SV*)SvRV(ST(0)));
	  THIS = INT2PTR(IXHV *, tmp);
	}
	else
	  Perl_croak(aTHX_ "Tie::Hash::LRU::STORABLE_freeze(): THIS is not a blessed SV reference")
;
#line 535 "LRU.xs"
		THI_DEBUG_METHOD1("%d", cloning);
		THI_CHECK_OBJECT;

		Copy(THI_SERIAL_ID, &s.rev.id[0], 4, char);
		s.rev.major = THI_SERIAL_REV_MAJOR;
		s.rev.minor = THI_SERIAL_REV_MINOR;

		XPUSHs(sv_2mortal(newSVpvn((char *)&s, sizeof(Serialized))));
		n = 1;
		for (cur = THIS->root->next; cur != THIS->root; cur = cur->next)
		{
		  XPUSHs(sv_2mortal(newRV_inc(cur->key)));
		  XPUSHs(sv_2mortal(newRV_inc(cur->val)));
		  n += 2;
		}

		XSRETURN(n);
#line 958 "LRU.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__Hash__LRU_STORABLE_thaw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__Hash__LRU_STORABLE_thaw)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "object, cloning, serialized, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
	int	cloning = (int)SvIV(ST(1))
;
	SV *	serialized = ST(2)
;
#line 561 "LRU.xs"
		THI_METHOD(STORABLE_thaw);
		IXHV *THIS;
		Serialized *ps;
		STRLEN len;
		int i;

#line 987 "LRU.c"
#line 568 "LRU.xs"
		THI_DEBUG_METHOD1("%d", cloning);

		if (!sv_isobject(object) || SvTYPE(SvRV(object)) != SVt_PVMG)
		  Perl_croak(aTHX_ XSCLASS "::%s: THIS is not "
		                           "a blessed SV reference", method);

		ps = (Serialized *) SvPV(serialized, len);

		if (len < sizeof(SerialRev) ||
		    strnNE(THI_SERIAL_ID, &ps->rev.id[0], 4))
		  Perl_croak(aTHX_ "invalid frozen "
		                   XSCLASS " object (len=%d)", len);

		if (ps->rev.major != THI_SERIAL_REV_MAJOR)
		  Perl_croak(aTHX_ "cannot thaw incompatible "
		                   XSCLASS " object");

		/* TODO: implement minor revision handling */

		Newz(0, THIS, 1, IXHV);
		sv_setiv((SV*)SvRV(object), PTR2IV(THIS));

		THIS->signature = THI_SIGNATURE;
		THIS->hv = newHV();
		THIS->iter = NULL;
		IxLink_new(THIS->root);

		if ((items-3) % 2)
		  Perl_croak(aTHX_ "odd number of items in STORABLE_thaw");

		for (i = 3; i < items; i+=2)
		{
		  IxLink *cur;
		  SV *key, *val;

		  key = SvRV(ST(i));
		  val = SvRV(ST(i+1));

		  IxLink_new(cur);
		  IxLink_push(THIS->root, cur);

		  cur->key = newSVsv(key);
		  cur->val = newSVsv(val);

		  val = newSViv(PTR2IV(cur));

		  if (hv_store_ent(THIS->hv, key, val, 0) == NULL)
		  {
		    SvREFCNT_dec(val);
		    Perl_croak(aTHX_ "couldn't store value");
		  }
		}

		XSRETURN_EMPTY;
#line 1043 "LRU.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Tie__Hash__LRU); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Tie__Hash__LRU)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Tie::Hash::LRU::TIEHASH", XS_Tie__Hash__LRU_TIEHASH, file, "$$;@");
        (void)newXSproto_portable("Tie::Hash::LRU::autohit", XS_Tie__Hash__LRU_autohit, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::DESTROY", XS_Tie__Hash__LRU_DESTROY, file, "$");
        (void)newXSproto_portable("Tie::Hash::LRU::FETCH", XS_Tie__Hash__LRU_FETCH, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::STORE", XS_Tie__Hash__LRU_STORE, file, "$$$");
        (void)newXSproto_portable("Tie::Hash::LRU::FIRSTKEY", XS_Tie__Hash__LRU_FIRSTKEY, file, "$");
        (void)newXSproto_portable("Tie::Hash::LRU::NEXTKEY", XS_Tie__Hash__LRU_NEXTKEY, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::EXISTS", XS_Tie__Hash__LRU_EXISTS, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::DELETE", XS_Tie__Hash__LRU_DELETE, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::CLEAR", XS_Tie__Hash__LRU_CLEAR, file, "$");
        (void)newXSproto_portable("Tie::Hash::LRU::SCALAR", XS_Tie__Hash__LRU_SCALAR, file, "$");
        (void)newXSproto_portable("Tie::Hash::LRU::STORABLE_freeze", XS_Tie__Hash__LRU_STORABLE_freeze, file, "$$");
        (void)newXSproto_portable("Tie::Hash::LRU::STORABLE_thaw", XS_Tie__Hash__LRU_STORABLE_thaw, file, "$$$;@");

    /* Initialisation Section */

#line 625 "LRU.xs"
#ifdef THI_DEBUGGING
		{
		  const char *str;
		  if ((str = getenv("THI_DEBUG_OPT")) != NULL)
		    set_debug_opt(aTHX_ str);
		}
#endif

#line 1102 "LRU.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
